unit find_virus;
interface
const
  NVirus  = 21;
  NFamily = 2;

  {vn: Virus Name}
  vnNone         =  0;
  vnDataLock     =  1;
  vn1701         =  2;
  vnFlip         =  3;
  vnJerusalem    =  4; {jerusalem, jerusalem-A, 1244}
  vnSlayer       =  5;
  vnTequila      =  6;
  vnTopo         =  7;
  vnDarkAvenger  =  8;
  vn584          =  9;
  vn706_768      =  10;
  vn855_880      =  11;
  vnSunday       =  12;
  vnKeyPressed   =  13;
  vn1030         =  14;
  vnAlabama      =  15;
  vn1554         =  16; {tenbyte}
  vnDoodle       =  17; {Yankee Doodle}
  vnBadBoy       =  18;
  vnDemolition   =  19;
  vnCansu        =  20;
  vnBebe         =  21;

  {vf: Virus Family}
  vfNone         =  0;
  vfJerusalem    =  1;
  vf855          =  2;

  {ss: Status of Scan}
  ssOK           =  0;
  ssScanOutRange =  1;

const VirusFamily:Array[1..NFamily] of string[11]=
                  ('Jerusalem',
                   '855');

type VirusRec=record
                Name:string[16];
                Family:byte;
              end;
      VirusTable=Array[1..NVirus] of VirusRec;
const VirusInfo:VirusTable=(
                (Name:  'DataLock';           Family: vfNone),
                (Name:  '1701';               Family: vfNone),
                (Name:  'Flip';               Family: vfNone),
                (Name:  'Jerusalem o 1244';   Family: vfJerusalem),
                (Name:  'Slayer';             Family: vfNone),
                (Name:  'Tequila';            Family: vfNone),
                (Name:  'Topo';               Family: vfNone),
                (Name:  'DarkAvenger';        Family: vfNone),
                (Name:  '584';                Family: vf855),
                (Name:  '706 o 768';          Family: vf855),
                (Name:  '855 o 880';          Family: vf855),
                (Name:  'Sunday';             Family: vfJerusalem),
                (Name:  'KeyPressed';         Family: vfNone),
                (Name:  '1030';               Family: vfNone),
                (Name:  'Alabama';            Family: vfNone),
                (Name:  '1554';               Family: vfNone),
                (Name:  'Yankee Doodle';      Family: vfNone),
                (Name:  'BadBoy';             Family: vfNone),
                (Name:  'Demolition';         Family: vfNone),
                (Name:  'Cansu';              Family: vfNone),
                (Name:  'Bebe';               Family: vfNone));


     {MMV:Menager of Virus in Memory}
Type MMV=object
       ScanReport:byte;
       Status:byte;
       Constructor Init(Find:byte);
       Destructor  Done;
       Procedure ReSearch; Virtual;
       Function Allert:Boolean; Virtual;
       Function WhatVirus:String; Virtual;
       Function WhatFamily:String; Virtual;
       Function ValidStatus:Boolean; Virtual;
       Function Version:word; Virtual;
     end;

var Find:byte;

implementation

procedure Search; forward;

Constructor MMV.Init(Find:byte);
begin
  ScanReport:=Find;
  if ScanReport > NVirus
   then begin
          Status:=ssScanOutRange;
          ScanReport:=vnNone
        end
   else Status:=ssOK
end;

Destructor MMV.Done;
begin
end;

Procedure MMV.ReSearch;
begin
  Search;
  ScanReport:=Find;
  Status:=ssOk;
end;

Function MMV.Allert:Boolean;
begin
  Allert:=ScanReport<>0;
end;

Function MMV.WhatVirus:String;
begin
  if ScanReport=vnNone
    then WhatVirus:='No known Virus found in memory'
    else WhatVirus:=VirusInfo[ScanReport].Name;
end;

Function MMV.WhatFamily:String;
begin
  if ScanReport=vnNone then WhatFamily:=''
   else if VirusInfo[ScanReport].Family=vfNone
              then WhatFamily:='none'
              else WhatFamily:=VirusFamily[VirusInfo[ScanReport].Family];
end;

Function MMV.ValidStatus:boolean;
begin
  ValidStatus:=Status=0;
end;

Function MMV.Version:word;
begin
  Version:=NVirus;
end;

procedure search;assembler;
const BabBoyTable:array[1..12] of byte=
        ($2e,$0ff,$36,$27,$01,$0E,$1F,$2E,$FF,$26,$25,$01);
asm
                              {DataLock}
       MOV  Find,vnDataLock
       MOV  AH,0BEh
       INT  21h
       CMP  AX,1234h
       JZ   @@virus_in_memory
                              {1701}
       MOV  Find,vn1701
       MOV  AX,4BFFh
       INT  21h
       CMP  DI,55AAh
       JE   @@virus_in_memory
                              {Flip}
       MOV  Find,vnFlip
       MOV  AX,0FE01h
       INT  21h
       CMP  AX,01FEh
       JE   @@virus_in_memory
                              {Jerusalem / 1244 / jerusalem-A}
       MOV  Find,vnJerusalem
       MOV  AH,0E0h
       INT  21h
       CMP  AH,0E0h
       JAE  @@not_jeru_in_mem
       CMP  AH,03h
       JB   @@not_jeru_in_mem
       JMP  @@virus_in_memory
   @@not_jeru_in_mem:
                               {Sunday}
       MOV  Find,vnSunday
       MOV  AH,0FFh
       INT  21h
       CMP  AH,0FFh
       JAE  @@not_Sun_in_mem
       CMP  AH,04h
       JB   @@not_Sun_in_mem
       JMP  @@virus_in_memory
   @@not_sun_in_mem:

                                 {Slayer}
       MOV  Find,vnSlayer
       MOV  AX,0F1FAh
       INT  21h
       CMP  AX,0AAAAh
       JE   @@virus_in_memory

                                 {Tequila}
       MOV  Find,vnTequila
       MOV  AX,0FE02h
       INT  21h
       CMP  AX,01FDh
       JE   @@virus_in_memory
                                 {1030}
       MOV  Find,vn1030
       MOV  AX,3521h
       INT  21h
       CMP  BX,200h
       JNE  @@not_1030_in_mem
   {   MOV  AX,3524h
       INT  21h
       CMP  BX,484h
       JE   @@virus_in_memory}
       JMP  @@virus_in_memory
    @@not_1030_in_mem:
                                 {Yankee Doodle}
       MOV  Find,vnDoodle
       MOV  AX,0C600h
       CLC
       INT  21h
       JNC  @@not_Doodle_in_mem
       CMP  AX,002Ch
       JE   @@Virus_in_memory
    @@not_Doodle_in_mem:
                                 {Demolition}
       MOV  Find,vnDemolition
       MOV  AX,4B7Fh
       INT  21h
       JNC  @@Virus_in_memory

                                  {BadBoy}
       MOV  Find,vnBadBoy
       MOV  ES,PrefixSeg
       MOV  ES,ES:[0002]
       MOV  SI,Offset BabBoyTable
       MOV  DI,100
       MOV  CX,000Bh
       REP  CMPSB
       JZ   @@Virus_in_memory
                                       {Bebe}
       MOV  Find,vnBebe
       MOV  AX,351Ch
       INT  21h
       MOV  AX,ES:[BX-2]
       CMP  AX,00FFh
       JNE  @@Not_Bebe_in_mem
       PUSH ES
       POP  AX
       OR   AX,AX
       JZ   @@Virus_in_memory
   @@Not_Bebe_In_mem:

                                         {Cansu}
       MOV  Find,vnCansu
       PUSH DS
       XOR  AX,AX
       MOV  DS,AX
       MOV  ES,DS:[004eh]
       MOV  BX,00D6h
       CMP  Word ptr ES:[BX],9876h
       JNE  @@not_Cansu_in_mem
       POP  DS
       JMP  @@Virus_in_memory
   @@not_Cansu_in_mem:
       POP  DS

                                 {Topo}
       MOV  Find,vnTopo
       XOR  BX,BX
       MOV  ES,BX
       MOV  AX,11h
       CMP  ES:[3FEh],AX     {0000:03fe}
       JE   @@virus_in_memory
                                 {DarkAvenger}
       MOV  Find,vnDarkAvenger
       PUSH DS
       {ES=0}
       LDS  AX,ES:[0080h]
       CMP  AX,2EEh
       JNE  @@not_Dark_in_mem
       LDS  AX,ES:[009Ch]
       CMP  AX,2A9h
       JNE  @@not_Dark_in_mem
       LDS  AX,ES:[004Ch]
       CMP  AX,6E4h
       JNE  @@not_Dark_in_mem
       POP  DS
       JMP  @@virus_in_memory
   @@not_Dark_in_mem:
       POP  DS

                                  {584 (della famiglia dell'855 -novembre 17-)}
       MOV  Find,vn584
       {ES=0}
       CMP  ES:[020Ch].byte,4Dh
       JE   @@virus_in_memory
                                  {855 e 880}
       MOV  Find,vn855_880
       {ES=0}
       CMP  ES:[020Ch].word,5856h
       JE   @@virus_in_memory
                                  {706 e 768 (della famiglia dell'855)}
       MOV  Find,vn706_768
       {ES=0}
       CMP  ES:[020Ch].byte,56
       JE   @@virus_in_memory
                                  {KeyPressed}
       MOV  Find,vnKeyPressed
       {ES=0}
       CMP  ES:[0600h].byte,1
       JE   @@virus_in_memory

       MOV  Find,vnAlabama
       {ES=0}
       MOV  AX,ES:[0]
       OR   AX,ES:[2]
       JZ   @@virus_in_memory
                                   {1554}
       MOV  Find,vn1554
       {ES=0}
       CMP  ES:[0084].word,0413h
       JNE  @@not_1554_in_mem
       CMP  ES:[0086].word,9A00h
       JE   @@virus_in_memory
  @@not_1554_in_mem:

       MOV  Find,vnNONE

@@virus_in_memory:

end;

begin
  search;
end.

{L'oggetto MMV restituisce tramite WhatVirus e WhatFamily informazioni
 associate al virus trovato. Va inizializzato passando la variabile Find,
 dopo di che si deve testare se ValidStatus=true per essere sicuri che la
 ricerca sia stata effettuata in modo corretto. Se Allert vale True allora
 c' un virus attivo in memoria. I metodi dell'oggetto (essendo virtuali)
 possono essere riscritti per gestire eventuali errori o ampliarne le
 caratteristiche.
 ReSearch serve per rifare la ricerca (ad esempio dopo che  stato eseguito
 un programma figlio o si era andati momentaneamente al dos.
}

{Nota per Yankee Doddle:
 il virus utilizza una chiamata a INT 21 funzione C603, ma la chiamata a
 C600  pi sicura (inquanto la precedente modifica anche dei registri in
 caso che il virus sia presente). Si potrebbe utilizzare la chiamata a C601
 (che restituisce AH=0 ma  meno sicura. E' di poca utilit la chiamata a
 C602 e C5xx
}

{Nota per Bebe:
 Bebe non  un TSR, ma quando attiva il suo effetto, copia il suo gestore
 dell'interrupt 1C nella memoria bassa (segmento 0000), e pone 2 byte prima
 della routine per sapere che c' il suo gestore attivo.
}